diff -uwr sourceold/AntiSpawnKill/AntiSpawnKill.vcxproj source/AntiSpawnKill/AntiSpawnKill.vcxproj
--- sourceold/AntiSpawnKill/AntiSpawnKill.vcxproj	2011-11-26 13:17:17.329101500 +0800
+++ source/AntiSpawnKill/AntiSpawnKill.vcxproj	2012-05-28 13:38:14.127546900 +0800
@@ -153,7 +153,7 @@
       <MinimalRebuild>false</MinimalRebuild>
       <ExceptionHandling>
       </ExceptionHandling>
-      <RuntimeLibrary>MultiThreadedDLL</RuntimeLibrary>
+      <RuntimeLibrary>MultiThreadedDebugDLL</RuntimeLibrary>
       <BufferSecurityCheck>false</BufferSecurityCheck>
       <FunctionLevelLinking>true</FunctionLevelLinking>
       <EnableEnhancedInstructionSet>NotSet</EnableEnhancedInstructionSet>
diff -uwr sourceold/CTF/CTF.cpp source/CTF/CTF.cpp
--- sourceold/CTF/CTF.cpp	2012-01-11 22:13:42.196289000 +0800
+++ source/CTF/CTF.cpp	2012-04-14 04:09:52.823242100 +0800
@@ -281,7 +281,7 @@
 		GameObject *Flag = Commands->Create_Object(mapConfiguration.CTFFlagPreset,FlagLoc);
 		Commands->Set_Player_Type(Flag,Team);
 		Commands->Set_Model(Flag,mapConfiguration.CTFFlagModel[Team]);
-		Commands->Attach_Script(Flag,"MDB_SSGM_CTF_Flag","");
+		Commands->Attach_Script(Flag,"SSGM_CTF_Flag","");
 		Commands->Attach_Script(Flag,"KAK_Prevent_Kill","");
 		Set_Flag_Location(Team,1);
 		return Flag;
@@ -452,6 +452,7 @@
 				tmp.Format("ppage %d %s Flag Captures: %d/%d - %s Flag Captures: %d/%d",PlayerID,str,CTFCaps[0],mapConfiguration.CTFCapLimit,str2,CTFCaps[1],mapConfiguration.CTFCapLimit);
 				delete[] str;
 				delete[] str2;
+				Console_Input(tmp);
 				return false;
 			}
 			if (wcsistr(Message,L"!flag") == Message)
diff -uwr sourceold/CTF/ctf.vcxproj source/CTF/ctf.vcxproj
--- sourceold/CTF/ctf.vcxproj	2011-11-26 13:17:40.789062500 +0800
+++ source/CTF/ctf.vcxproj	2012-05-28 13:38:15.341414100 +0800
@@ -153,7 +153,7 @@
       <MinimalRebuild>false</MinimalRebuild>
       <ExceptionHandling>
       </ExceptionHandling>
-      <RuntimeLibrary>MultiThreadedDLL</RuntimeLibrary>
+      <RuntimeLibrary>MultiThreadedDebugDLL</RuntimeLibrary>
       <BufferSecurityCheck>false</BufferSecurityCheck>
       <FunctionLevelLinking>true</FunctionLevelLinking>
       <EnableEnhancedInstructionSet>NotSet</EnableEnhancedInstructionSet>
diff -uwr sourceold/CharacterRefund/CharacterRefund.vcxproj source/CharacterRefund/CharacterRefund.vcxproj
--- sourceold/CharacterRefund/CharacterRefund.vcxproj	2011-11-26 13:17:53.663085900 +0800
+++ source/CharacterRefund/CharacterRefund.vcxproj	2012-05-28 13:38:15.684187600 +0800
@@ -153,7 +153,7 @@
       <MinimalRebuild>false</MinimalRebuild>
       <ExceptionHandling>
       </ExceptionHandling>
-      <RuntimeLibrary>MultiThreadedDLL</RuntimeLibrary>
+      <RuntimeLibrary>MultiThreadedDebugDLL</RuntimeLibrary>
       <BufferSecurityCheck>false</BufferSecurityCheck>
       <FunctionLevelLinking>true</FunctionLevelLinking>
       <EnableEnhancedInstructionSet>NotSet</EnableEnhancedInstructionSet>
diff -uwr sourceold/ExtraConsoleCommands/ExtraConsoleCommands.vcxproj source/ExtraConsoleCommands/ExtraConsoleCommands.vcxproj
--- sourceold/ExtraConsoleCommands/ExtraConsoleCommands.vcxproj	2011-11-26 13:17:47.099609300 +0800
+++ source/ExtraConsoleCommands/ExtraConsoleCommands.vcxproj	2012-05-28 13:38:15.609968800 +0800
@@ -153,7 +153,7 @@
       <MinimalRebuild>false</MinimalRebuild>
       <ExceptionHandling>
       </ExceptionHandling>
-      <RuntimeLibrary>MultiThreadedDLL</RuntimeLibrary>
+      <RuntimeLibrary>MultiThreadedDebugDLL</RuntimeLibrary>
       <BufferSecurityCheck>false</BufferSecurityCheck>
       <FunctionLevelLinking>true</FunctionLevelLinking>
       <EnableEnhancedInstructionSet>NotSet</EnableEnhancedInstructionSet>
diff -uwr sourceold/FirstBlood/FirstBlood.vcxproj source/FirstBlood/FirstBlood.vcxproj
--- sourceold/FirstBlood/FirstBlood.vcxproj	2011-11-26 13:17:33.343750000 +0800
+++ source/FirstBlood/FirstBlood.vcxproj	2012-05-28 13:38:14.959578200 +0800
@@ -153,7 +153,7 @@
       <MinimalRebuild>false</MinimalRebuild>
       <ExceptionHandling>
       </ExceptionHandling>
-      <RuntimeLibrary>MultiThreadedDLL</RuntimeLibrary>
+      <RuntimeLibrary>MultiThreadedDebugDLL</RuntimeLibrary>
       <BufferSecurityCheck>false</BufferSecurityCheck>
       <FunctionLevelLinking>true</FunctionLevelLinking>
       <EnableEnhancedInstructionSet>NotSet</EnableEnhancedInstructionSet>
diff -uwr sourceold/MemoryManager/MemTracker.cpp source/MemoryManager/MemTracker.cpp
--- sourceold/MemoryManager/MemTracker.cpp	2011-10-11 21:35:07.162109300 +0800
+++ source/MemoryManager/MemTracker.cpp	2012-04-17 17:41:01.289062500 +0800
@@ -17,6 +17,7 @@
 #include <MMSystem.h>
 #pragma warning (disable:6387)
 #include <shlobj.h>
+#include <shlwapi.h>
 #pragma warning (default:6387)
 #pragma comment(lib, "winmm.lib")
 #include "FastAllocator.h"
@@ -59,10 +60,13 @@
 	char path_to_exe[256];
 	GetModuleFileNameA(NULL, path_to_exe, sizeof(path_to_exe));
 	strrchr(path_to_exe,'\\')[0] = 0;
+	SetCurrentDirectoryA(path_to_exe);
 	strcat(path_to_exe,"\\");
 	strcat(path_to_exe,LEAK_LOG_DIR);
+	if (!PathFileExistsA(path_to_exe))
+	{
 	SHCreateDirectoryExA(NULL,path_to_exe,NULL);
-
+	}
 	FILE* leakLogFile = fopen(LEAK_LOG_DIR "\\leaks.txt", "wb");
 	if (!leakLogFile)
 		OutputDebugStringA("Failed to write to " LEAK_LOG_DIR "\\leaks.txt");
diff -uwr sourceold/MemoryManager/MemoryManager.vcxproj source/MemoryManager/MemoryManager.vcxproj
--- sourceold/MemoryManager/MemoryManager.vcxproj	2011-11-26 13:17:56.498046800 +0800
+++ source/MemoryManager/MemoryManager.vcxproj	2012-05-28 13:38:16.140242300 +0800
@@ -61,7 +61,7 @@
       <StringPooling>true</StringPooling>
       <ExceptionHandling>
       </ExceptionHandling>
-      <RuntimeLibrary>MultiThreadedDLL</RuntimeLibrary>
+      <RuntimeLibrary>MultiThreadedDebugDLL</RuntimeLibrary>
       <PrecompiledHeader>
       </PrecompiledHeader>
       <AssemblerOutput>AssemblyAndSourceCode</AssemblerOutput>
@@ -78,6 +78,7 @@
       <SubSystem>Windows</SubSystem>
       <TargetMachine>MachineX86</TargetMachine>
       <OutputFile>$(OutDir)$(TargetName)$(TargetExt)</OutputFile>
+      <AdditionalDependencies>kernel32.lib;user32.lib;gdi32.lib;winspool.lib;comdlg32.lib;advapi32.lib;shell32.lib;ole32.lib;oleaut32.lib;uuid.lib;odbc32.lib;odbccp32.lib;shlwapi.lib;%(AdditionalDependencies)</AdditionalDependencies>
     </Link>
     <PostBuildEvent>
       <Command>if defined RenPath (
@@ -130,6 +131,7 @@
       <EnableCOMDATFolding>true</EnableCOMDATFolding>
       <TargetMachine>MachineX86</TargetMachine>
       <OutputFile>$(OutDir)$(TargetName)$(TargetExt)</OutputFile>
+      <AdditionalDependencies>kernel32.lib;user32.lib;gdi32.lib;winspool.lib;comdlg32.lib;advapi32.lib;shell32.lib;ole32.lib;oleaut32.lib;uuid.lib;odbc32.lib;odbccp32.lib;shlwapi.lib;%(AdditionalDependencies)</AdditionalDependencies>
     </Link>
     <PostBuildEvent>
       <Command>if defined RenPath (
diff -uwr sourceold/Mute/Mute.cpp source/Mute/Mute.cpp
--- sourceold/Mute/Mute.cpp	2012-01-11 22:15:17.976562500 +0800
+++ source/Mute/Mute.cpp	2012-04-09 23:34:39.794921800 +0800
@@ -148,7 +148,7 @@
 		}
 	}
 
-	virtual bool OnRadioCommand(int PlayerType, int PlayerID, int AnnouncementID, int IconID, uint8 AnnouncementType)
+	virtual bool OnRadioCommand(int PlayerType, int PlayerID, int AnnouncementID, int IconID, AnnouncementEnum AnnouncementType)
 	{
 		if(MutedPlayers[PlayerID] == false)
 		{
diff -uwr sourceold/Mute/Mute.vcxproj source/Mute/Mute.vcxproj
--- sourceold/Mute/Mute.vcxproj	2011-11-26 13:18:02.164062500 +0800
+++ source/Mute/Mute.vcxproj	2012-05-28 13:38:16.400984400 +0800
@@ -153,7 +153,7 @@
       <MinimalRebuild>false</MinimalRebuild>
       <ExceptionHandling>
       </ExceptionHandling>
-      <RuntimeLibrary>MultiThreadedDLL</RuntimeLibrary>
+      <RuntimeLibrary>MultiThreadedDebugDLL</RuntimeLibrary>
       <BufferSecurityCheck>false</BufferSecurityCheck>
       <FunctionLevelLinking>true</FunctionLevelLinking>
       <EnableEnhancedInstructionSet>NotSet</EnableEnhancedInstructionSet>
diff -uwr sourceold/NoPoints/NoPoints.vcxproj source/NoPoints/NoPoints.vcxproj
--- sourceold/NoPoints/NoPoints.vcxproj	2011-11-26 13:17:34.499023400 +0800
+++ source/NoPoints/NoPoints.vcxproj	2012-05-28 13:38:15.014265700 +0800
@@ -153,7 +153,7 @@
       <MinimalRebuild>false</MinimalRebuild>
       <ExceptionHandling>
       </ExceptionHandling>
-      <RuntimeLibrary>MultiThreadedDLL</RuntimeLibrary>
+      <RuntimeLibrary>MultiThreadedDebugDLL</RuntimeLibrary>
       <BufferSecurityCheck>false</BufferSecurityCheck>
       <FunctionLevelLinking>true</FunctionLevelLinking>
       <EnableEnhancedInstructionSet>NotSet</EnableEnhancedInstructionSet>
diff -uwr sourceold/PointsDistribution/PointsDistribution.cpp source/PointsDistribution/PointsDistribution.cpp
--- sourceold/PointsDistribution/PointsDistribution.cpp	2012-01-11 22:20:50.635742100 +0800
+++ source/PointsDistribution/PointsDistribution.cpp	2012-04-24 13:45:18.509765600 +0800
@@ -14,6 +14,7 @@
 #include "DamagePoints.h"
 #include "gmgame.h"
 #include "Iterator.h"
+#include "SoldierGameObj.h"
 
 void* HookupAT3x(void* a, void* b, void* c, void* patch_start, void* patch_end, int (*version_selector)())
 {
@@ -49,23 +50,23 @@
 
 	virtual void OnObjectCreate(void *data,GameObject *obj)
 	{
-		if(Is_Soldier(obj) && EnabledForInfantry == true)
+		if (obj->As_SoldierGameObj() && EnabledForInfantry == true)
 		{
 			Attach_Script_Once(obj,"CollectDamage","");
 		}
-		else if (Is_Vehicle(obj) && EnabledForVehicles == true) 
+		else if (obj->As_VehicleGameObj() && EnabledForVehicles == true) 
 		{
 			Attach_Script_Once(obj,"CollectDamage","");
 		}
-		else if (Is_Beacon(obj) && EnabledForBeacons == true) 
+		else if (obj->As_PhysicalGameObj() && obj->As_PhysicalGameObj()->As_BeaconGameObj() && EnabledForBeacons == true) 
 		{
 			Attach_Script_Once(obj,"CollectDamage","");
 		}
-		else if (Is_C4(obj) && EnabledForC4 == true) 
+		else if (obj->As_PhysicalGameObj() && obj->As_PhysicalGameObj()->As_C4GameObj() && EnabledForC4 == true) 
 		{
 			Attach_Script_Once(obj,"CollectDamage","");
 		}
-		else if(Is_Building(obj) && EnabledForBuildings == true)
+		else if(obj->As_BuildingGameObj() && EnabledForBuildings == true)
 		{
 			Attach_Script_Once(obj,"CollectDamage","");
 		}
diff -uwr sourceold/PointsDistribution/PointsDistribution.vcxproj source/PointsDistribution/PointsDistribution.vcxproj
--- sourceold/PointsDistribution/PointsDistribution.vcxproj	2011-11-26 13:17:39.563476500 +0800
+++ source/PointsDistribution/PointsDistribution.vcxproj	2012-05-28 13:38:15.275007900 +0800
@@ -153,7 +153,7 @@
       <MinimalRebuild>false</MinimalRebuild>
       <ExceptionHandling>
       </ExceptionHandling>
-      <RuntimeLibrary>MultiThreadedDLL</RuntimeLibrary>
+      <RuntimeLibrary>MultiThreadedDebugDLL</RuntimeLibrary>
       <BufferSecurityCheck>false</BufferSecurityCheck>
       <FunctionLevelLinking>true</FunctionLevelLinking>
       <EnableEnhancedInstructionSet>NotSet</EnableEnhancedInstructionSet>
diff -uwr sourceold/Spectate/Spectate.cpp source/Spectate/Spectate.cpp
--- sourceold/Spectate/Spectate.cpp	2012-01-11 22:21:06.802734300 +0800
+++ source/Spectate/Spectate.cpp	2012-05-02 14:15:37.150390600 +0800
@@ -16,6 +16,7 @@
 #include "CommandLineParser.h"
 #include "engine_tt.h"
 #include "SoldierGameObj.h"
+#include "VehicleGameObj.h"
 #include "WeaponBagClass.h"
 #include "engine_weap.h"
 #include "engine_obj2.h"
@@ -145,10 +146,15 @@
 
 void Spectate(GameObject *obj,int id)
 {
-	int team = Get_Team(Get_Player_ID(obj));
+	SoldierGameObj *soldier = obj->As_SoldierGameObj();
+	int team = soldier->Get_Player_Type();
 	if(team != -4)
 	{
-		SoldierGameObj *soldier = obj->As_SoldierGameObj();
+		if (soldier->Get_Vehicle())
+		{
+			Console_Output("Can't enable spectate mode when in a vehicle\n");
+			return;
+		}
 		if (!Get_Fly_Mode(soldier))
 		{
 			Toggle_Fly_Mode(soldier);
@@ -161,10 +167,6 @@
 		Commands->Set_Is_Rendered(soldier,false);
 		Commands->Set_Shield_Type(soldier,"Blamo");
 		Disarm_All_C4_Beacons(id);
-		if (soldier->Get_Vehicle())
-		{
-			Soldier_Transition_Vehicle(soldier);
-		}
 		for (SLNode<cPlayer>* PlayerIter = Get_Player_List()->Head(); (PlayerIter != NULL); PlayerIter = PlayerIter->Next())
 		{
 			cPlayer *p = PlayerIter->Data();
diff -uwr sourceold/Spectate/Spectate.vcxproj source/Spectate/Spectate.vcxproj
--- sourceold/Spectate/Spectate.vcxproj	2011-11-26 13:17:57.673828100 +0800
+++ source/Spectate/Spectate.vcxproj	2012-05-28 13:38:16.221296900 +0800
@@ -153,7 +153,7 @@
       <MinimalRebuild>false</MinimalRebuild>
       <ExceptionHandling>
       </ExceptionHandling>
-      <RuntimeLibrary>MultiThreadedDLL</RuntimeLibrary>
+      <RuntimeLibrary>MultiThreadedDebugDLL</RuntimeLibrary>
       <BufferSecurityCheck>false</BufferSecurityCheck>
       <FunctionLevelLinking>true</FunctionLevelLinking>
       <EnableEnhancedInstructionSet>NotSet</EnableEnhancedInstructionSet>
diff -uwr sourceold/SuddenDeath/SuddenDeath.cpp source/SuddenDeath/SuddenDeath.cpp
--- sourceold/SuddenDeath/SuddenDeath.cpp	2012-01-11 22:16:29.383789000 +0800
+++ source/SuddenDeath/SuddenDeath.cpp	2012-04-24 13:46:41.072265600 +0800
@@ -16,6 +16,7 @@
 #include "CommandLineParser.h"
 #include "GameObjManager.h"
 #include "VehicleGameObj.h"
+#include "BuildingGameObj.h"
 #include "engine_tt.h"
 
 void* HookupAT3x(void* a, void* b, void* c, void* patch_start, void* patch_end, int (*version_selector)())
@@ -178,7 +179,7 @@
 	while (x)
 	{
 		GameObject *o = (GameObject *)x->Data();
-		if (o && Is_Building(o))
+		if (o && o->As_BuildingGameObj())
 		{
 			Commands->Attach_Script(o, "SuddenDeathBuilding", "");
 		}
@@ -204,7 +205,7 @@
 	}
 	if(The_Game()->Get_Game_Duration_S() <= 300) //If it less than 5 minutes into the game.
 	{
-		if(Is_Refinery(obj))
+		if(obj->As_BuildingGameObj() && obj->As_BuildingGameObj()->As_RefineryGameObj())
 		{
 			if(suddendeath.ActivateOnRefs == true)
 			{
diff -uwr sourceold/SuddenDeath/SuddenDeath.vcxproj source/SuddenDeath/SuddenDeath.vcxproj
--- sourceold/SuddenDeath/SuddenDeath.vcxproj	2011-11-26 13:17:24.999023400 +0800
+++ source/SuddenDeath/SuddenDeath.vcxproj	2012-05-28 13:38:14.452742300 +0800
@@ -153,7 +153,7 @@
       <MinimalRebuild>false</MinimalRebuild>
       <ExceptionHandling>
       </ExceptionHandling>
-      <RuntimeLibrary>MultiThreadedDLL</RuntimeLibrary>
+      <RuntimeLibrary>MultiThreadedDebugDLL</RuntimeLibrary>
       <BufferSecurityCheck>false</BufferSecurityCheck>
       <FunctionLevelLinking>true</FunctionLevelLinking>
       <EnableEnhancedInstructionSet>NotSet</EnableEnhancedInstructionSet>
diff -uwr sourceold/crates/crates.cpp source/crates/crates.cpp
--- sourceold/crates/crates.cpp	2012-01-11 22:29:04.188476500 +0800
+++ source/crates/crates.cpp	2012-04-24 13:41:43.463867100 +0800
@@ -123,16 +123,16 @@
 		mapConfiguration = globalConfiguration;
 		const StringClass key = StringClass(The_Game()->Get_Map_Name()).AsLower() + "_Crates";
 		LoadGenericINISettings(SSGMIni, key, mapConfiguration);
-		mapConfiguration.CrateVehSpawnPos[0].X = SSGMIni->Get_Float(key, "NodRVCx", mapConfiguration.CrateVehSpawnPos[0].X);
-		mapConfiguration.CrateVehSpawnPos[0].Y = SSGMIni->Get_Float(key, "NodRVCy", mapConfiguration.CrateVehSpawnPos[0].Y);
-		mapConfiguration.CrateVehSpawnPos[0].Z = SSGMIni->Get_Float(key, "NodRVCz", mapConfiguration.CrateVehSpawnPos[0].Z);
-		mapConfiguration.CrateVehSpawnPos[1].X = SSGMIni->Get_Float(key, "GDIRVCx", mapConfiguration.CrateVehSpawnPos[1].X);
-		mapConfiguration.CrateVehSpawnPos[1].Y = SSGMIni->Get_Float(key, "GDIRVCy", mapConfiguration.CrateVehSpawnPos[1].Y);
-		mapConfiguration.CrateVehSpawnPos[1].Z = SSGMIni->Get_Float(key, "GDIRVCz", mapConfiguration.CrateVehSpawnPos[1].Z);
+		mapConfiguration.CrateVehSpawnPos[0].X = SSGMIni->Get_Float(key, "NodRVCX", mapConfiguration.CrateVehSpawnPos[0].X);
+		mapConfiguration.CrateVehSpawnPos[0].Y = SSGMIni->Get_Float(key, "NodRVCY", mapConfiguration.CrateVehSpawnPos[0].Y);
+		mapConfiguration.CrateVehSpawnPos[0].Z = SSGMIni->Get_Float(key, "NodRVCZ", mapConfiguration.CrateVehSpawnPos[0].Z);
+		mapConfiguration.CrateVehSpawnPos[1].X = SSGMIni->Get_Float(key, "GDIRVCX", mapConfiguration.CrateVehSpawnPos[1].X);
+		mapConfiguration.CrateVehSpawnPos[1].Y = SSGMIni->Get_Float(key, "GDIRVCY", mapConfiguration.CrateVehSpawnPos[1].Y);
+		mapConfiguration.CrateVehSpawnPos[1].Z = SSGMIni->Get_Float(key, "GDIRVCZ", mapConfiguration.CrateVehSpawnPos[1].Z);
 	}
 	virtual void OnObjectCreate(void *data,GameObject *obj)
 	{
-		if (Is_Powerup(obj))
+		if (obj->As_PhysicalGameObj() && obj->As_PhysicalGameObj()->As_PowerUpGameObj())
 		{
 			if (stristr(Commands->Get_Preset_Name(obj),"crate"))
 			{
@@ -420,8 +420,8 @@
 					StringClass cine;
 					cine.Format("%scrate.txt",Commands->Get_Player_Type(sender)	== 0?"Nod":"GDI");
 					Commands->Attach_Script(Temp,"Test_Cinematic",cine);
-					GameObject *veh = Commands->Create_Object(RandomVehicle[Index][3],Vector3(0,0,0));
-					Commands->Send_Custom_Event(Temp,Temp,CUSTOM_EVENT_CINEMATIC_SET_FIRST_SLOT+4,Commands->Get_Preset_ID(veh),0);
+					GameObject *veh = Commands->Create_Object(RandomVehicle[Index][2],Vector3(0,0,0));
+					Commands->Send_Custom_Event(Temp,Temp,CUSTOM_EVENT_CINEMATIC_SET_FIRST_SLOT+4,Commands->Get_ID(veh),0);
 					StringClass msg;
 					const char *str = Get_Team_Name(Team);
 					msg.Format("msg Crate: Looks like %s just got a random vehicle! Go them!",str);
@@ -645,7 +645,7 @@
 					int team = Commands->Get_Player_Type(sender);
 					Commands->Send_Custom_Event(obj,sender,100101,1,1);//enable generating of money on player
 					message2.Format("%ls picked up a Human Silo crate.",Get_Wide_Player_Name(sender));
-					message1.Format("ppage %d [Crate] You got the Human Silo Crate, your entier team will be granted an additional $1 credit a second until you die or change character.",Get_Player_ID(sender));
+					message1.Format("ppage %d [Crate] You got the Human Silo Crate, your entire team will be granted an additional $1 credit a second until you die or change character.",Get_Player_ID(sender));
 					Create_2D_WAV_Sound_Team("m00pc$$_aqob0002i1evag_snd.wav",team);//credits acquired
 					Vector3	pos	= Commands->Get_Position(sender);
 					message3.Format("CRATE;HUMANSILO;;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
diff -uwr sourceold/crates/crates.vcxproj source/crates/crates.vcxproj
--- sourceold/crates/crates.vcxproj	2011-11-26 13:17:42.841796800 +0800
+++ source/crates/crates.vcxproj	2012-05-28 13:38:15.428328200 +0800
@@ -153,7 +153,7 @@
       <MinimalRebuild>false</MinimalRebuild>
       <ExceptionHandling>
       </ExceptionHandling>
-      <RuntimeLibrary>MultiThreadedDLL</RuntimeLibrary>
+      <RuntimeLibrary>MultiThreadedDebugDLL</RuntimeLibrary>
       <BufferSecurityCheck>false</BufferSecurityCheck>
       <FunctionLevelLinking>true</FunctionLevelLinking>
       <EnableEnhancedInstructionSet>NotSet</EnableEnhancedInstructionSet>
diff -uwr sourceold/example-plugin/example-plugin.vcxproj source/example-plugin/example-plugin.vcxproj
--- sourceold/example-plugin/example-plugin.vcxproj	2011-11-26 13:17:22.956054600 +0800
+++ source/example-plugin/example-plugin.vcxproj	2012-05-28 13:38:14.331648500 +0800
@@ -65,7 +65,7 @@
       <MinimalRebuild>false</MinimalRebuild>
       <ExceptionHandling>
       </ExceptionHandling>
-      <RuntimeLibrary>MultiThreadedDLL</RuntimeLibrary>
+      <RuntimeLibrary>MultiThreadedDebugDLL</RuntimeLibrary>
       <BufferSecurityCheck>false</BufferSecurityCheck>
       <FunctionLevelLinking>true</FunctionLevelLinking>
       <EnableEnhancedInstructionSet>NotSet</EnableEnhancedInstructionSet>
diff -uwr sourceold/makemix/general.cpp source/makemix/general.cpp
--- sourceold/makemix/general.cpp	2009-04-12 11:54:00.781250000 +0800
+++ source/makemix/general.cpp	2012-05-02 02:02:33.078125000 +0800
@@ -1 +1,12 @@
+/*	Renegade Scripts.dll
+	Copyright 2011 Tiberian Technologies
+
+	This file is part of the Renegade scripts.dll
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
+	Software Foundation; either version 2, or (at your option) any later
+	version. See the file COPYING for more details.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+	Only the source code to the module(s) containing the licenced code has to be released.
+*/
 #include "general.h"
diff -uwr sourceold/makemix/general.h source/makemix/general.h
--- sourceold/makemix/general.h	2011-03-08 09:59:47.156250000 +0800
+++ source/makemix/general.h	2012-05-02 02:02:38.716796800 +0800
@@ -1,3 +1,14 @@
+/*	Renegade Scripts.dll
+	Copyright 2011 Tiberian Technologies
+
+	This file is part of the Renegade scripts.dll
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
+	Software Foundation; either version 2, or (at your option) any later
+	version. See the file COPYING for more details.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+	Only the source code to the module(s) containing the licenced code has to be released.
+*/
 #ifndef ACHASH_INCLUDE__GENERAL_H
 #define ACHASH_INCLUDE__GENERAL_H
 #include "Defines.h"
diff -uwr sourceold/makemix/makemix.cpp source/makemix/makemix.cpp
--- sourceold/makemix/makemix.cpp	2011-11-26 13:48:43.054687500 +0800
+++ source/makemix/makemix.cpp	2012-05-02 02:02:43.840820300 +0800
@@ -1,3 +1,14 @@
+/*	Renegade Scripts.dll
+	Copyright 2011 Tiberian Technologies
+
+	This file is part of the Renegade scripts.dll
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
+	Software Foundation; either version 2, or (at your option) any later
+	version. See the file COPYING for more details.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+	Only the source code to the module(s) containing the licenced code has to be released.
+*/
 #include "General.h"
 #include "MixFileFactoryClass.h"
 #include "SimpleFileFactoryClass.h"
diff -uwr sourceold/makemix/makemix.vcxproj source/makemix/makemix.vcxproj
--- sourceold/makemix/makemix.vcxproj	2011-11-26 13:17:26.556640600 +0800
+++ source/makemix/makemix.vcxproj	2012-05-28 13:38:14.603132900 +0800
@@ -123,7 +123,7 @@
       <MinimalRebuild>false</MinimalRebuild>
       <ExceptionHandling>
       </ExceptionHandling>
-      <RuntimeLibrary>MultiThreadedDLL</RuntimeLibrary>
+      <RuntimeLibrary>MultiThreadedDebugDLL</RuntimeLibrary>
       <BufferSecurityCheck>false</BufferSecurityCheck>
       <FunctionLevelLinking>true</FunctionLevelLinking>
       <EnableEnhancedInstructionSet>NotSet</EnableEnhancedInstructionSet>
diff -uwr sourceold/randomstartingcredits/RandomStartingCredits.vcxproj source/randomstartingcredits/RandomStartingCredits.vcxproj
--- sourceold/randomstartingcredits/RandomStartingCredits.vcxproj	2011-11-26 13:17:37.231445300 +0800
+++ source/randomstartingcredits/RandomStartingCredits.vcxproj	2012-05-28 13:38:15.165632900 +0800
@@ -153,7 +153,7 @@
       <MinimalRebuild>false</MinimalRebuild>
       <ExceptionHandling>
       </ExceptionHandling>
-      <RuntimeLibrary>MultiThreadedDLL</RuntimeLibrary>
+      <RuntimeLibrary>MultiThreadedDebugDLL</RuntimeLibrary>
       <BufferSecurityCheck>false</BufferSecurityCheck>
       <FunctionLevelLinking>true</FunctionLevelLinking>
       <EnableEnhancedInstructionSet>NotSet</EnableEnhancedInstructionSet>
diff -uwr sourceold/scripts/AirFactoryGameObj.h source/scripts/AirFactoryGameObj.h
--- sourceold/scripts/AirFactoryGameObj.h	2011-10-21 09:32:28.004882800 +0800
+++ source/scripts/AirFactoryGameObj.h	2012-05-23 15:32:38.041015600 +0800
@@ -21,7 +21,7 @@
 	~AirFactoryGameObj (void);
 	virtual	void					Init( void );
 	void								Init (const AirFactoryGameObjDef & definition);
-	const AirFactoryGameObjDef &	Get_Definition (void) const;
+	SCRIPTS_API const AirFactoryGameObjDef &	Get_Definition (void) const;
 	AirFactoryGameObj *				As_AirFactoryGameObj (void)	{ return this; }
 	bool									Save (ChunkSaveClass &csave);
 	bool									Load (ChunkLoadClass &cload);
@@ -40,6 +40,11 @@
 	void					Import_Rare (BitStreamClass &packet);
 	void					Export_Rare (BitStreamClass &packet);
 	void					Create_Vehicle(int defintion_id,SoldierGameObj * player);
+	void Set_Busy(bool busy)
+	{
+		IsBusy = busy;
+		Set_Object_Dirty_Bit(NetworkObjectClass::BIT_RARE,true);
+	}
 private:
 	void					Load_Variables (ChunkLoadClass &cload);	
 	ReferencerClass	Vehicle;
diff -uwr sourceold/scripts/AirFactoryGameObjDef.h source/scripts/AirFactoryGameObjDef.h
--- sourceold/scripts/AirFactoryGameObjDef.h	2011-10-11 21:37:09.316406200 +0800
+++ source/scripts/AirFactoryGameObjDef.h	2012-05-06 16:37:04.946203100 +0800
@@ -22,6 +22,9 @@
 	bool									Save (ChunkSaveClass &csave);
 	bool									Load (ChunkLoadClass &cload);
 	const PersistFactoryClass &	Get_Factory (void) const;
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+#endif
 	DECLARE_EDITABLE (AirFactoryGameObjDef, BuildingGameObjDef);
 protected:
 	void					Load_Variables (ChunkLoadClass &cload);
diff -uwr sourceold/scripts/AirStripGameObj.h source/scripts/AirStripGameObj.h
--- sourceold/scripts/AirStripGameObj.h	2011-10-11 21:37:11.875976500 +0800
+++ source/scripts/AirStripGameObj.h	2012-05-23 11:12:05.150390600 +0800
@@ -46,7 +46,7 @@
 	virtual const PersistFactoryClass& Get_Factory() const;
 	virtual void Init();
 	void Init(const AirStripGameObjDef&);
-	const AirStripGameObjDef & Get_Definition( void ) const ;
+	SCRIPTS_API const AirStripGameObjDef & Get_Definition( void ) const ;
 	virtual bool Save(ChunkSaveClass&);
 	virtual bool Load(ChunkLoadClass&);
 	void Load_Variables(ChunkLoadClass&);
diff -uwr sourceold/scripts/AirStripGameObjDef.h source/scripts/AirStripGameObjDef.h
--- sourceold/scripts/AirStripGameObjDef.h	2011-10-11 21:37:14.416992100 +0800
+++ source/scripts/AirStripGameObjDef.h	2012-05-06 16:37:04.961828100 +0800
@@ -29,6 +29,9 @@
 	virtual bool                       Load         (ChunkLoadClass& chunkLoader);
 	virtual uint32                     Get_Class_ID () const;
 	virtual PersistClass*              Create       () const;
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+#endif
 	DECLARE_EDITABLE (AirStripGameObjDef, VehicleFactoryGameObjDef);
 private:
 	void					Load_Variables (ChunkLoadClass &cload);
diff -uwr sourceold/scripts/ArmedGameObj.h source/scripts/ArmedGameObj.h
--- sourceold/scripts/ArmedGameObj.h	2011-10-11 21:37:23.454101500 +0800
+++ source/scripts/ArmedGameObj.h	2012-05-23 11:12:13.034179600 +0800
@@ -23,7 +23,7 @@
 	void							Init( const ArmedGameObjDef & definition );
 	void							Copy_Settings( const ArmedGameObjDef & definition );
 	void							Re_Init( const ArmedGameObjDef & definition );
-	const	ArmedGameObjDef & Get_Definition( void ) const ;
+	SCRIPTS_API const	ArmedGameObjDef & Get_Definition( void ) const ;
 	virtual	bool				Save( ChunkSaveClass & csave );
 	virtual	bool				Load( ChunkLoadClass & cload );
 	virtual	void				On_Post_Load( void );
@@ -32,7 +32,7 @@
 	virtual	void				Import_State_Cs( BitStreamClass & packet );
 	virtual	void				Export_State_Cs( BitStreamClass & packet );
 	virtual	void				Post_Think();
-	WeaponClass	*				Get_Weapon( void );
+	SCRIPTS_API WeaponClass	*				Get_Weapon( void );
 	WeaponBagClass	*			Get_Weapon_Bag( void )						{ return WeaponBag; }
 	bool							Muzzle_Exists( int index = 0 );
 	virtual const Matrix3D &Get_Muzzle( int index = 0 );
diff -uwr sourceold/scripts/ArmedGameObjDef.h source/scripts/ArmedGameObjDef.h
--- sourceold/scripts/ArmedGameObjDef.h	2011-10-11 21:37:26.043945300 +0800
+++ source/scripts/ArmedGameObjDef.h	2012-05-06 16:37:04.974523400 +0800
@@ -18,6 +18,9 @@
 	ArmedGameObjDef( void );
 	virtual bool								Save( ChunkSaveClass &csave );
 	virtual bool								Load( ChunkLoadClass &cload );
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+#endif
 	DECLARE_EDITABLE(ArmedGameObjDef,PhysicalGameObjDef);
 protected:
 	//All of these floats are in radians (although leveledit shows degrees)
diff -uwr sourceold/scripts/ArmorWarheadManager.h source/scripts/ArmorWarheadManager.h
--- sourceold/scripts/ArmorWarheadManager.h	2011-10-11 21:57:50.799804600 +0800
+++ source/scripts/ArmorWarheadManager.h	2012-04-17 22:47:21.643554600 +0800
@@ -11,17 +11,20 @@
 */
 #ifndef TT_INCLUDE__ARMORWARHEADMANAGER_H
 #define TT_INCLUDE__ARMORWARHEADMANAGER_H
+#ifdef DDBEDIT
+#error cant use this in ddbedit
+#endif
 #include "engine_string.h"
 #include "datasafe.h"
-class ArmorWarheadManager
+class SCRIPTS_API ArmorWarheadManager
 {
 public:
 	static void	Init( void );
 	static void Shutdown( void );
 	static bool				Is_Armor_Soft( ArmorType armor );
 	static int			 	Get_Num_Armor_Types( void );
-	static ArmorType		SCRIPTS_API Get_Armor_Type( const char *name );
-	static const char SCRIPTS_API * 	Get_Armor_Name( ArmorType type );
+	static ArmorType		Get_Armor_Type( const char *name );
+	static const char * 	Get_Armor_Name( ArmorType type );
 	static int			 	Get_Num_Warhead_Types( void );
 	static WarheadType	Get_Warhead_Type( const char *name );
 	static const char *	Get_Warhead_Name( WarheadType type );
diff -uwr sourceold/scripts/AudibleSoundClass.h source/scripts/AudibleSoundClass.h
--- sourceold/scripts/AudibleSoundClass.h	2012-02-21 10:03:50.199218700 +0800
+++ source/scripts/AudibleSoundClass.h	2012-04-14 04:09:47.960937500 +0800
@@ -154,7 +154,7 @@
   virtual void                Free_Miles_Handle       ();
   virtual void                Initialize_Miles_Handle ();
   virtual void                Allocate_Miles_Handle   ();
-  virtual SoundBufferClass*   Get_Buffer              () const;
+  virtual SHADERS_API SoundBufferClass*   Get_Buffer              () const;
   virtual SoundBufferClass*   Peek_Buffer             () const;
   SHADERS_API virtual void                Set_Buffer              (SoundBufferClass* buffer);
   virtual void                Restart_Loop            ();
